#ifndef _CALIBRATION_H_
#define _CALIBRATION_H_

//#define SWITCH_MOTORS
#define SWITCH_OPTOS

#define XTAL 4000000

//definitions for the compass enable and AREF enable modes
#define COMPASS_ENABLE_DDR_PORT  DDRC
#define COMPASS_ENABLE_PORT      PORTC
#define COMPASS_ENABLE_PIN       3

#define AREF_ENABLE_DDR_PORT     DDRA
#define AREF_ENABLE_PORT         PORTA
#define AREF_ENABLE_PIN          7  

#include <hardware.h>

/*odometry functions */
#define left_opto_enable() cbi(LEFT_OPTO_DDR,LEFT_OPTO_BIT)
#define right_opto_enable() cbi(RIGHT_OPTO_DDR,RIGHT_OPTO_BIT)
#define feedback_enable()  sbi(FEEDBACK_ENABLE_DDR,FEEDBACK_ENABLE_BIT); sbi(FEEDBACK_ENABLE_PORT,FEEDBACK_ENABLE_BIT); 

/*motors functions */
#define right_motor_start() sbi(MOTOR_ENABLE_DDR,LEFT_MOTOR_ENABLEBIT);sbi(MOTOR_ENABLE_PORT,LEFT_MOTOR_ENABLEBIT);
#define left_motor_start()  sbi(MOTOR_ENABLE_DDR,RIGHT_MOTOR_ENABLEBIT);sbi(MOTOR_ENABLE_PORT,RIGHT_MOTOR_ENABLEBIT);
#define right_motor_stop()  sbi(MOTOR_ENABLE_DDR,LEFT_MOTOR_ENABLEBIT);cbi(MOTOR_ENABLE_PORT,LEFT_MOTOR_ENABLEBIT);
#define left_motor_stop()   sbi(MOTOR_ENABLE_DDR,RIGHT_MOTOR_ENABLEBIT);cbi(MOTOR_ENABLE_PORT,RIGHT_MOTOR_ENABLEBIT);

#define Enable_LeftWheel_Interrupt()       sbi(INTERRUPT_MASK_REGISTER,COUNTER0_ENABLE_BIT)
#define Initialize_LeftWheel_Interrupt()    outp(INITIAL_COUNTER_VALUE,LEFT_FEEDBACK_COUNTER)
#define Scale_LeftWheel_Interrupt()          outp(FEEDBACK_CLOCK_FREQUENCY,TCCR0)
#define Initialize_RightWheel_CompareRegister()  outp(FINAL_COUNTER_VALUE,OCR1AH); outp(INITIAL_COUNTER_VALUE,OCR1AL);//16bit register
#define Scale_RightWheel_Interrupt()       outp(INITIAL_COUNTER_VALUE,TCCR1A);outp(FEEDBACK_CLOCK_FREQUENCY,TCCR1B);//16bit register
#define Initialize_RightWheel_Interrupt()    outp(INITIAL_COUNTER_VALUE,TCNT1L);outp(INITIAL_COUNTER_VALUE,TCNT1H);   
#define Enable_RightWheel_Compare_Match()  sbi(INTERRUPT_MASK_REGISTER,COUNTER1_COMPARE_MATCH_BIT)


#define Enable_Main_Interrupt()           sbi(INTERRUPT_MASK_REGISTER,COUNTER2_ENABLE_BIT)
#define Initialize_Main_Interrupt()       outp(INITIAL_COUNTER_VALUE,MAIN_COUNTER)
#define Scale_Main_Interrupt()            outp(MAIN_CLOCK_FREQUENCY,TCCR2)

#define External_Interrupt_Enable()   sbi(EXTERNAL_INTERRUPT_REGISTER,EXTERNAL_INTERRUPT_ENABLE_BIT)
#define Compare_Match_Enable()        sbi(INTERRUPT_MASK_REGISTER,COUNTER2_COMPARE_MATCH_BIT)

#define Enable_Compass_Charge()         sbi(COMPASS_CHARGE_DDR,COMPASS_CHARGE_BIT)
#define Charge_Compass()                sbi(COMPASS_CHARGE_PORT,COMPASS_CHARGE_BIT)
#define DisCharge_Compass()             cbi(COMPASS_CHARGE_PORT,COMPASS_CHARGE_BIT)

#endif

/*
#define MAX_VEL  17 
#define MAX_INTERVAL 6
#define PWM_LEVELS {0,70,75,115,120,135,160,165,185,200,210,220,230,240,250,255};
#define INTERVALS {0,7,5,3,2,1};//mapped to maximum observable distance i.e. 45
//#define PWM_LEVELS {0,  85, 100, 115, 130, 145, 160, 175, 190, 205, 220};
#define left_pwm_error  0
#define right_pwm_error 0

#define LEFT_THRESHOLD  5
#define RIGHT_THRESHOLD 5

#define ODO_WHEEL_TICS 6
#define ODO_WHEEL_SEPARATION (1.85*64)  
#define ODO_LEFT_WHEEL_CIRCUMFERENCE  (1.979*64)
#define ODO_RIGHT_WHEEL_CIRCUMFERENCE (1.979*64) 



#include "hardware.h"
#define ODO_LEFT_WHEEL_FORWARD_ANGLE  (((double)ODO_LEFT_WHEEL_CIRCUMFERENCE/((double)ODO_WHEEL_TICS*(double)ODO_WHEEL_SEPARATION*2.0)))
#define ODO_RIGHT_WHEEL_FORWARD_ANGLE  (((double)-ODO_RIGHT_WHEEL_CIRCUMFERENCE/((double)ODO_WHEEL_TICS*(double)ODO_WHEEL_SEPARATION*2.0)))
#define ODO_LEFT_WHEEL_TRAVEL ((double)(ODO_LEFT_WHEEL_CIRCUMFERENCE*1024)/((double)ODO_WHEEL_TICS*2.0))
#define ODO_RIGHT_WHEEL_TRAVEL ((double)(ODO_RIGHT_WHEEL_CIRCUMFERENCE*1024)/((double)ODO_WHEEL_TICS*2.0))

#endif
*/


