#ifndef _HARDWARE_H_
#define _HARDWARE_H_


#define OPTO_EN_BIT  2
#define OPTO_EN_PIN  PINC
#define OPTO_EN_PORT PORTC
#define OPTO_EN_DDR  DDRC


#define IR_EN_DDR DDRC
#define IR_EN_PORT PORTC
#define IR_EN_BIT 4



#ifndef SWITCH_MOTORS
//swap these to switch pwm to l and r motors (switch dir bit too) 
#define LEFT_PWM_REG    OCR1AL
#define RIGHT_PWM_REG   OCR1BL
//swap these to switch dir port - this is just for future porting ease 
#define LEFT_DIR_DDR    DDRD
#define LEFT_DIR_PORT   PORTD
#define LEFT_DIR_BIT    7
#define RIGHT_DIR_DDR   DDRD
#define RIGHT_DIR_PORT  PORTD
#define RIGHT_DIR_BIT   6
#else
/* swap these to switch pwm to l and r motors (switch dir bit too) */
#define LEFT_PWM_REG    OCR1BL
#define RIGHT_PWM_REG   OCR1AL
/* swap these to switch dir port - this is just for future porting ease */
#define LEFT_DIR_DDR    DDRD
#define LEFT_DIR_PORT   PORTD
#define LEFT_DIR_BIT    6
#define RIGHT_DIR_DDR   DDRD
#define RIGHT_DIR_PORT  PORTD
#define RIGHT_DIR_BIT   7
#endif

//#ifndef SWITCH_OPTOS
/* swap these to switch l and r optical encoders */
#define LEFT_OPTO_BIT   0    // 6
//#define LEFT_OPTO_PIN           PINC
#define LEFT_OPTO_DDR   DDRB     //DDRC

#define RIGHT_OPTO_BIT  1 // 0
//#define RIGHT_OPTO_PIN   PINB
#define RIGHT_OPTO_DDR   DDRB

#define FEEDBACK_ENABLE_BIT 2 
#define FEEDBACK_ENABLE_DDR  DDRC
#define FEEDBACK_ENABLE_PORT PORTC

#define MAIN_COUNTER           TCNT2
#define LEFT_FEEDBACK_COUNTER  TCNT0
#define RIGHT_FEEDBACK_COUNTER TCNT1
#define FEEDBACK_CLOCK_FREQUENCY 0x07

#define INITIAL_COUNTER_VALUE  0x00
#define FINAL_COUNTER_VALUE    0xff


#define LEFT_MOTOR_ENABLEBIT 5
#define RIGHT_MOTOR_ENABLEBIT 4

#define MOTOR_ENABLE_DDR  DDRD
#define MOTOR_ENABLE_PORT PORTD

#define MAIN_CLOCK_FREQUENCY 0x05
#define INTERRUPT_MASK_REGISTER  TIMSK
#define COUNTER2_COMPARE_MATCH_BIT OCIE2
#define COUNTER1_COMPARE_MATCH_BIT OCIE1A    

#define COUNTER2_ENABLE_BIT    TOIE2
#define COUNTER0_ENABLE_BIT    TOIE0


#define EXTERNAL_INTERRUPT_REGISTER GIMSK
#define EXTERNAL_INTERRUPT_ENABLE_BIT 6 

#define MPU_STATUS_REGISTER MCUCR

#define COMPASS_CHARGE_DDR  DDRC
#define COMPASS_CHARGE_PORT PORTC
#define COMPASS_CHARGE_BIT  5



//#else
//#define LEFT_OPTO_BIT   0
//#define LEFT_OPTO_PIN   PINB
//#define LEFT_OPTO_DDR   DDRB

//#define RIGHT_OPTO_BIT  6
//#define RIGHT_OPTO_PIN  PINC
//#define RIGHT_OPTO_DDR  DDRC
//#endif


#endif
