
#ifndef _OPTO_ODO_H_
#define _OPTO_ODO_H_

#include "io.h"
#include "interrupt.h"
#include "sig-avr.h"
#include "math.h"
#include "calibration.h"

/*
struct location_t {
    int32_t x;
    int32_t y;
};
*/

struct odometry_t {
    /*struct location_t lw;
    struct location_t rw;*/
    int32_t x, y;
    int32_t lx, ly;
    int32_t des_x, des_y;
    double last_heading_offset;
    double heading;
    double des_heading;
};

extern struct odometry_t odometry;

#define right_opto()   (inp(RIGHT_OPTO_PIN) & (1<<RIGHT_OPTO_BIT))
#define left_opto()    (inp(LEFT_OPTO_PIN) & (1<<LEFT_OPTO_BIT))

inline uint32_t get_left_odo(void);
inline uint32_t get_right_odo(void);
inline void init_opto_odos(void);
inline uint8_t get_left_tics(void);
inline uint8_t get_right_tics(void);
inline void integrate_opto(void);
inline void integrate_odo(void);
inline void moveto(int32_t x, int32_t y);
inline void rmoveto(int32_t x, int32_t y);
inline double calc_des_heading_offset(void);

#endif
