#include "io.h"
#include "interrupt.h"
#include "sig-avr.h"
#include "rm_defs.h"
#include "robomote.h"
#include "motor.h"
#include "opto_odo.h"
#include "compass.h"
#include "comm.h"
#include <definitions.h>
#include <extcommdef.h>
#ifdef DEBUG
#include "itoa.h"
#endif
uint8_t msg[ROBO_MSG_SIZE];
static struct {
    uint8_t msg_type;
    union {
        uint8_t parm;
        struct {
            uint32_t y;
            uint32_t x;
        } where;
        uint8_t data[8];
    } msg;
} rx_msg;

#define TX_BUF_SIZE 2*5
uint8_t tx_buf[TX_BUF_SIZE];
uint8_t tx_buf2[ROBO_MSG_SIZE];
static struct {
    int8_t rx_pend;
    int8_t tx_pend;
    int8_t tx_pos;
} state;
inline void initialize_variables()
{
 timeout=0;
 rx_pending=0;
 comm_flag=0;
 SEND_COUNTER=0;
 COMMAND_COMPLETED_TICKS=0;
 COMMAND_COMPLETED_ACK_PENDING=0;
 COMMAND_COMPLETED_TIME_OUT=0;
 req_counter=0;
 req_flag=0;
 RESET=1;
 done_flag=1;
 val1=0;
 val2=0;
 val3=0;
 sq=0;
}
inline void send(uint8_t smsg)
{
    //if(rm_state == RM_RESET_WAIT) {
      //  state.tx_pend=0;
       // state.tx_pos=0;
    //} else {
        switch(smsg) {
        case MOVE_RECEIVED:
	   state.tx_pend=0;	
	case NEW_AZIMUTH:
      		update_azimuth_buf();
	  break;
        case RM_OBJECT_DETECT:
	      tx_buf2[0]=0;
	      state.tx_pend=1;
	      break;
	case TIME_OUT: 
	  state.tx_pend=0;
	  break;
	case MOVE_TIME_OUT:
	  state.tx_pend=0;
	  break;
	case COMMAND_RECEIVED_ACK:
	  state.tx_pend=0;
	  break;
	case COMMAND_EXECUTED:
	  state.tx_pend=0;
	  break;
	case REQUEST_RESEND:
	case RM_CMD_DONE:
	case RM_RXTX_ERROR:
	  state.tx_pend=0;
	  break;
	default:
	  break;
        }
        loop_until_bit_is_set(USR, UDRE);
        outp(smsg, UDR);
    //}
}


inline void send_azimuth(void)
{

for(;;)
 {	
  if(compass_lock==1){break;}
 }
compass_lock=1;//hold till u get done with azimuth 
compass_flag=1;
init_compass();
}

inline void update_azimuth_buf(void)
 {
  if(state.tx_pend==0)
   {
    tx_buf2[0]=(unsigned char)azimuth;
    state.tx_pend=1;
   }		   
 } 

SIGNAL(SIG_UART_TRANS) {
    //if(rm_state == RM_RESET_WAIT) {
      //  state.tx_pend=0;
       // state.tx_pos=0;
    //}
	if(state.tx_pend>0) {
        state.tx_pend--;
        outp(tx_buf2[state.tx_pend], UDR);
    }
}

SIGNAL(SIG_INTERRUPT1) {
if(inp(USR) & 0x80){
  if(rx_pending==0) {
    rx_msg.msg.parm=inp(UDR);
    if(rx_msg.msg_type==RM_ALIGN && rx_msg.msg.parm==RM_RESET) {
      reset();
      rm_state=RM_READY;
    } else {
      rx_msg.msg_type=rx_msg.msg.parm;
      if (rm_state!=RM_RESET_WAIT) {
	ticks =50; 
	timeout=0;
	comm_flag=0;
	switch(rx_msg.msg_type) {
	case RM_ALIGN: break;
	case NEW_AZIMUTH: send(COMMAND_RECEIVED_ACK); timeout=0; comm_flag=1;send_azimuth();rx_pending=0;break;
	case RM_SET_VELOCITY: rx_pending=1; break; 
	case RM_SET_BIAS: rx_pending=1; break;	  
	case RM_MOVE:rx_pending=1;break;
	case COMMAND_COMPLETED_ACK_RECEIVED: 
          COMMAND_COMPLETED_ACK_PENDING=0;
	  RESET=1;
	  done_flag=0;
	  COMMAND_COMPLETED_TIME_OUT=0;
	  break;
	default:send(RM_RXTX_ERROR);  break;
	  
	}
      }
    }
    } else {
      
        rx_pending--;
	rx_msg.msg.data[rx_pending]=inp(UDR);
	
	if(rx_pending==0) {
	  send(COMMAND_RECEIVED_ACK);	 
	  timeout=0;
	  comm_flag=1;
	  switch(rx_msg.msg_type) {
	  case RM_SET_VELOCITY: if(sq==0)		   
			        { req_counter=50;req_flag=1;
				 sq=1;val1=rx_msg.msg.parm;break;}
	  case RM_SET_BIAS:     if(sq==0)
			        {req_counter=50;req_flag=1;
			         sq=2;val2=rx_msg.msg.parm;break;}
	  case RM_SET_HEADING:  break;
	  case RM_SET_IR_THRESH: break;  
	  case RM_MOVE: if(sq!=0) {
				          req_flag=0;
				          val3=rx_msg.msg.parm;
				          if(sq==1){set_vel(val1);move(val3);val1=0;val3=0;sq=0;break;}
		       			  else if(sq==2){set_bias(val2);move(val3);val2=0;val3=0;sq=0;break;}					  
                                  }           
	  case RM_SLEEP: break;
	  }
        }
    }
   }
}

inline void init_serial(void)
{  
  cli();
  rx_msg.msg_type=0;
  rx_pending=0;
  state.tx_pend=0;
  state.tx_pos=0;
  outp(BAUDDIV, UBRR);
  outp((1<<RXCIE)|(1<<RXEN)|(1<<TXEN)|(1<<TXCIE), UCR);
  initialize_variables();
  sei();

}
