#include "compass.h"
#include "comm.h"
#include "rm_defs.h"
#include <compassdefinitions.h>
#include <extcompassdef.h>
#define AVENUM  8
#define  PI 3.14159265
#define  Scale 0.708333

inline void delay(int n)
{
 int i,j;
 for(i=0;i<n;i++)
 {
  j=0;	 
 }
}
inline void charge_compass()
{
 Enable_Compass_Charge();
 Charge_Compass();
 delay(1000);
 DisCharge_Compass();
 delay(500);
 compass_lock=1;
}	

inline void enable_compass(void)
{	
sbi(COMPASS_ENABLE_DDR_PORT, COMPASS_ENABLE_PIN);
sbi(COMPASS_ENABLE_PORT, COMPASS_ENABLE_PIN);
 /* aref enable */
sbi(AREF_ENABLE_DDR_PORT, AREF_ENABLE_PIN);
sbi(AREF_ENABLE_PORT, AREF_ENABLE_PIN);
}
void init_compass(void)
{
  cli();
  compass_count=0;
  channel=0;
  /* enable adc for channel 0 */
  outp((1<<ADPS0)|(1<<ADPS2)|(1<<ADEN)|(1<<ADSC)|(0<<ADFR)|(1<<ADIE), ADCSR);
  outp(channel,ADMUX); 
  sei();
}

void set_heading(uint8_t h)
{
  des_azimuth = h;
}

SIGNAL(COMPASS_INTERRUPT)
{
  static int16_t  x_mag, y_mag;
  static uint16_t adc0_min= 0x7fff, adc0_max = 0;
  static uint16_t adc1_min= 0x7fff, adc1_max = 0;
  static uint16_t adc0=0, adc1=0;
  static uint16_t adc0_temp=0,adc1_temp=0;
  static uint8_t lsb0,msb0,lsb1,msb1;

  if(channel){  //channel 1
   lsb1 = inp(ADCL);
   msb1 = inp(ADCH) & 0x03;
   compass_count++; 
   channel = 0;
   /* set other channel -- */
   if(compass_count!=8)
      {
       outp(channel,ADMUX);
       outp((1<<ADPS0)|(1<<ADPS2)|(1<<ADEN)|(1<<ADSC)|(0<<ADFR)|(1<<ADIE), ADCSR);
       sei();
      }
  }  
  else{         //channel 0
   lsb0 = inp(ADCL);
   msb0 = inp(ADCH) & 0x03;
   compass_count++;
   channel = 1;
   if(compass_count!=8)
    {
      outp(channel,ADMUX);
      outp((1<<ADPS0)|(1<<ADPS2)|(1<<ADEN)|(1<<ADSC)|(0<<ADFR)|(1<<ADIE), ADCSR);
      sei();
     }
  }  
  
  if(channel==0) {      
    adc0= ( (msb0 & 0x03)*256 + ((lsb0>>4) & 0x0f) * 
16 + (lsb0 & 0x0f) );
    adc1= ( (msb1 & 0x03)*256 + ((lsb1>>4) & 0x0f) * 
16 + (lsb1 & 0x0f) );
    adc0_temp=adc0_temp+adc0;
    adc1_temp=adc1_temp+adc1;
    if(adc0_max<adc0)adc0_max=adc0;
    if(adc0_min>adc0)adc0_min=adc0;
    if(adc1_max<adc1)adc1_max=adc1;
    if(adc1_min>adc1)adc1_min=adc1;
    if(compass_count==8)
       {
         adc0_temp=(adc0_temp>>2);
	 adc1_temp=(adc1_temp>>2);     
         x_mag =((adc0)- (adc0_max + adc0_min)/2);
         y_mag =((adc1)- (adc1_max + adc1_min)/2);
	 calc_azimuth(x_mag,y_mag);
       }
  
 }
}

void calc_azimuth(int16_t x_mag,int16_t y_mag)
{
 int16_t az=0;
 uint16_t angle;
  if(x_mag==0) {
              if( y_mag < 0) { az= (uint16_t)90;  }
              if( y_mag > 0) { az= (uint16_t)270; }
              }
        else {
	       angle = calc_heading(x_mag,y_mag);
	       if( x_mag < 0) { az=(uint16_t)((180)-(angle));}
	       if( x_mag > 0 && y_mag <0) {az=(uint16_t) ( (-1) *(angle));}
	       if(x_mag>0 && y_mag>0) {az=(uint16_t)(360 -(angle));}
	    }

        azimuth = (uint8_t)( az * Scale);
/* release the compass flag */
 compass_count=0;
 send(NEW_AZIMUTH);
 compass_flag=0;
 //release the lock 
 compass_lock=0;	 
}	
int16_t calc_heading(int16_t xd, int16_t yd)
{		
float division;
int16_t val;
static  int16_t calc_angle;
static  int quadrant;
    if(yd==0)
	 {		
   		if(xd==0)
   			{	   
   			    calc_angle=0;
			}	 
		if(xd>0)
   			{		  
   				calc_angle =0; 
   			}
  		if((xd)<0)
   			{		  
  				calc_angle=180;
  			 }
 	}
 	if(yd!=0) 
	{ 
  		if(xd==0)
   		{
    		if(yd>0)
     			{   
     				calc_angle=90;
	 			}
    
			if(yd<0)
     			{
     				calc_angle=270; 
	 			}
   		} 
		if(xd!=0) 		
		{
 		 		     
			if(((yd)>0) && ((xd)>0))
   				{		 
   					quadrant=1;
				}  
 			if(((yd)<0) && ((xd)<0))
   				{		 
   					quadrant=3;
  				}  
 			if(((yd)>0) && ((xd)<0))
   				{		 
   					quadrant=2;
   				}
 			if(((yd)<0) && ((xd)>0))
  				{		 
   					quadrant=4;
  				}  
			if(quadrant==4 || quadrant ==2)
 				{		
 					division= division * -1 ; // converting in to positive value so absolute diff can be taken	
 
				}
 		  	 
	                if(xd<0 ) { xd = xd * -1;} if(yd<0) {yd=yd*-1;}
	                division = (float)((float) (yd) / (float)(xd));
                  	calc_angle = lookup_angle(division,quadrant);
  		       
		}// end of x value checking
 	}//end of y value checking 
if(quadrant==1  || quadrant== 3 )
{
 calc_angle = calc_angle;		
}

if(quadrant==2  || quadrant==4)
 {
 calc_angle =-calc_angle;
 }		 
val=calc_angle;// uint16 to int problem
return val;
}// end of calc_heading function

int16_t lookup_angle(float division,int quadrant)
{
if(division<= 0.08749)
  {
  return (int16_t)0;
  }		 
if(division<= 0.2679)
  {
  return (int16_t)(10);
  }
if(division<= 0.4663)
  {
  return (int16_t)(20);
  }			
if(division<=0.7002)
  {
  return (int16_t)(30);
  }
if(division<= 1.00)
  {
  return (int16_t)(40);
  }
if(division<=1.4281)													
 {
  return (int16_t)(50);
 }
if(division <=2.1445)
 {
 return (int16_t)(60);
 }
if(division <=3.7321)
{
 return(int16_t)(70);
 }		
if(division <=11.4301)
{		
return (int16_t)(80);
}		
if(division >11.4301)
 { 		
return (int16_t)(90);
 }  
else 
 return 0;

}// end of function	*/


