/* 
  Gabe Sibley 7.29.01 

  "integrates" interrupts from ir & sends RM_OBJECT_DETECT msg.
*/


#include "ir.h"
#include "comm.h"

//#define DEBUG 3

#ifdef DEBUG
#include "itoa.h"
#endif

uint16_t ir_threshold;
uint16_t ir_hits;
uint8_t  obj_detect;

inline void init_ir(void)
{
  uint8_t tmp;
  ir_threshold = 400;
  ir_hits = 0;
  obj_detect = 0;
  
  cli();

  /* enable ir, active low */
  tmp = inp(DDRC);
  outp((1<<4)|tmp, DDRC);
  //sbi(IR_EN_DDR, IR_EN_BIT);
  //cbi(IR_EN_PORT, IR_EN_BIT);  //  active low
  cbi(PORTC, 4);  //  active low

  tmp = inp(GIMSK);
  outp((1<<INT0), GIMSK);
  outp((1<<ISC01)|(1<<ISC11), MCUCR);
  sei();

}

inline void set_ir_thresh(uint8_t t)
{
  ir_threshold = t*20;
}

#define object_detect get_ir
inline uint8_t get_ir(void)
{
  if(!obj_detect)
    return 0;     
  obj_detect = 0;
  return 1;
}

inline void integrate_ir(void)
{
  static uint32_t prev_ir_hits;

  if( (ir_hits - prev_ir_hits) > ir_threshold){
    //msg[0] = RM_OBJECT_DETECT;
    //msg[1] = get_ir_thresh() | get_bumpers();
    //send(msg, 2);
    //msg[1] = 'I'; /* I for Infrared yo */
    //send(RM_OBJECT_DETECT, get_ir_thresh() | get_bumpers());
    send(RM_OBJECT_DETECT);
    obj_detect = 1;
  }

  prev_ir_hits = ir_hits;
  ir_hits = 0;
}


INTERRUPT(SIG_INTERRUPT0)
{
  ir_hits++;
}
