/* 
  HARDIK SHAH   
  SANDEEP BABEL

  setup motors and distance(time_interval) to move and velocity(% of interval while pwm are one)  
*/

#include "math.h"
#include "motor.h"
#include "ir.h"
#include "opto_odo.h"
#include "comm.h"
#include "robomote.h"
#include <motordefinitions.h>
inline void init_pwm(void)
{
  des_distance=0;
  des_left_count = 0;
  des_right_count = 0;
  des_count    = 0;
  des_bias     = 0;
  time_count   = 0;
  move_clr=0;
  move_flag=0;
  feed_count1=0;
  feed_count2=0;
  direction=1;
 /* set output pins for dir control */
  set_dir();
}
inline void set_vel(uint8_t v)
{
 des_count=v; 
 set_dir();
 des_bias = 0;           
 update_vel();
}

inline void set_bias(int8_t b)
 {
  des_bias = b;
  if(des_bias>0)
    {	   
     set_left_dir();    
     direction=1;
     des_count=des_bias;
    }	     
   else if (des_bias<0)  
    {
     set_right_dir();    
     des_bias=(des_bias*-1);
     des_count=des_bias;
    }  
    update_vel();
 }

inline void move(uint8_t d)
{
 if(des_bias==0)
  {
   des_distance=(d*50);//50ticks/cm
  }
 else if(des_bias!=0)
  {
  des_distance=(d*17);
  }	  
  move_clr=1;
  init_feed();
}

inline void update_vel(void)
{
 des_left_count=des_count;
 des_right_count=des_count;
 feed_count1=des_left_count;
 feed_count2=des_right_count;
}

uint8_t limit_range(int16_t n)
{
  if(n > 255)
    n = 255;
  if(n < 0)
    n = 0;
  return n;
}
inline void set_dir()
{
sbi(LEFT_DIR_DDR, LEFT_DIR_BIT);
cbi(LEFT_DIR_PORT, LEFT_DIR_BIT);
sbi(RIGHT_DIR_DDR, RIGHT_DIR_BIT);
sbi(RIGHT_DIR_PORT, RIGHT_DIR_BIT);
}

inline void set_left_dir()
{
 sbi(LEFT_DIR_DDR, LEFT_DIR_BIT);
 sbi(LEFT_DIR_PORT, LEFT_DIR_BIT);
 sbi(RIGHT_DIR_DDR, RIGHT_DIR_BIT);
 sbi(RIGHT_DIR_PORT, RIGHT_DIR_BIT);
}

inline void set_right_dir()
{
 sbi(LEFT_DIR_DDR, LEFT_DIR_BIT);
 cbi(LEFT_DIR_PORT, LEFT_DIR_BIT);
 sbi(RIGHT_DIR_DDR, RIGHT_DIR_BIT);
 cbi(RIGHT_DIR_PORT, RIGHT_DIR_BIT);
}	
