#define ENABLE_BIT_DEFINITIONS
#define LEFT 1
#define RIGHT 2
#include "ina90.h"
#include "io.h"
#include "interrupt.h"
#include "sig-avr.h"
#include "rm_defs.h"
#include <calibration.h>
#include "robomote.h"
#include "motor.h" 
#include "opto_odo.h"
#include "compass.h"
#include "comm.h"
#include "robomotedefinitions.h"
#include "extrobomotedef.h"
static inline void update_odo()
{
 left_odo=left_odo+l;
 right_odo=right_odo+r; 
}	
static inline void send_ack()
{
COMMAND_COMPLETED_ACK_PENDING=1;
RESET=0;
SEND_COUNTER=0;
COMMAND_COMPLETED_TIME_OUT=0;
COMMAND_COMPLETED_TICKS=100; 
done_flag=0;
send(COMMAND_EXECUTED);
}
static inline void off_leds()
{
 sbi(DDRC,0);sbi(PORTC,0);
 sbi(DDRC,1);sbi(PORTC,1);
}	
inline void start_both_motors()
{	
right_motor_start();
left_motor_start();
}	
inline void stop_motors()
{
right_motor_stop();
left_motor_stop();
}
void init_opto()
{
left_opto_enable();
right_opto_enable();
feedback_enable();
}
void init_main()
{
cli();
Compare_Match_Enable();
Enable_Main_Interrupt();
Initialize_Main_Interrupt();
Scale_Main_Interrupt();
External_Interrupt_Enable();
outp((1<<ISC11)|(1<<ISC10),MCUCR);
sei();
}
void init_feed()
{
cli();
l=0;r=0;
Enable_LeftWheel_Interrupt();
Initialize_LeftWheel_Interrupt();
Scale_LeftWheel_Interrupt();
Scale_RightWheel_Interrupt();
Initialize_RightWheel_Interrupt();
Initialize_RightWheel_CompareRegister();
Enable_RightWheel_Compare_Match();
if(move_clr==1)
{
  l=0;r=0;
  feedback_counter1=0;feedback_counter0=0;
  lsb0=0;msb0=0;dw=0;dwi=0;ll_new=0;rr_new=0;ll_ins=0;rr_ins=0;
  lsb1=0;msb1=0;
  move_flag=1;
 } 
sei();
}	

inline void communicate()
{
 if(req_counter>0)
 {
   req_counter--;
 }
 if(req_counter==0 && req_flag==1)
 {
 //send(REQUEST_RESEND);
 req_flag=0;
 }
if(ticks > 0 && rx_pending!=0)
  {
    ticks --;
  }
if(ticks==0 && rx_pending!=0)
   {
    timeout =1;
    rx_pending=0;
    if(timeout)
     {
      if(comm_flag==0)
      {
      //  send(TIME_OUT);
      	comm_flag=1;
      }
    }
  }
if(COMMAND_COMPLETED_TICKS>0 && COMMAND_COMPLETED_ACK_PENDING!=0)
  {
    COMMAND_COMPLETED_TICKS--;
  }
 if(COMMAND_COMPLETED_TICKS==0 && COMMAND_COMPLETED_ACK_PENDING!=0)
   {
     COMMAND_COMPLETED_TIME_OUT=1;

     if(COMMAND_COMPLETED_TIME_OUT && (RESET==0))
       {
         if((done_flag==0) && (SEND_COUNTER<2))
           {
            // send(COMMAND_EXECUTED);
             SEND_COUNTER++;
             done_flag=0;
             RESET=0;
             COMMAND_COMPLETED_ACK_PENDING=1;
             COMMAND_COMPLETED_TICKS=100;
           }

   	if((done_flag==0)&& (SEND_COUNTER>=2))
      	{
  	  //  send(RM_RXTX_ERROR);
  	    RESET=1;
   	    done_flag=1;
   	    COMMAND_COMPLETED_ACK_PENDING=0;
    	 }
     }
   }
}
inline void pi_controller()
{
 if(l+r<des_distance)
  {	
   lsb0=inp(TCNT0);
   lsb1=inp(TCNT1L);
   feedback_counter0= (msb0 << 8);
   feedback_counter0= ((feedback_counter0)| lsb0);
   feedback_counter1= (msb1 <<8);
   feedback_counter1= ((feedback_counter1) | lsb1);
   l=feedback_counter0;
   r=feedback_counter1;
   	if(l<ll_new){ll_ins=0;}
   	else if(l>ll_new){ ll_ins=l-ll_new;}
   	if(r<rr_new){rr_ins=0;}
   	else if(r>rr_new){ rr_ins=r-rr_new;}
   	ll_new=l;
  	rr_new=r;
   	if((ll_ins!=0 && rr_ins==0) || (rr_ins!=0 && ll_ins==0))
   	 {
     	  dw=0;
     	  flag=0;
    	 }
        else if(ll_ins>rr_ins)
        {
    	 dw=(ll_ins- rr_ins);
         flag=1;
   	}
        else if(rr_ins>ll_ins)
        {
         dw= (rr_ins-ll_ins);
         flag=2;
        }
       else if(rr_ins==ll_ins)
       {
        flag=0;dw=0;
       }
      if ((dw>50)||(dw<0)){dw=0;}
      else if((dw)>=0 && (dw<50))
       {
        dw=2*dw;
       }
      if((flag==1) ||(flag==0))
      {
       feed_count1=des_left_count-dw;
       feed_count2=des_right_count+dw;
      }
     else if(flag==2)
     {
      feed_count1=des_left_count+dw;
      feed_count2=des_right_count-dw;
     } 
     flag=0;
     if(feed_count1>255 || feed_count1<0){feed_count1=des_left_count;}
     if(feed_count2>255 || feed_count2<0){feed_count2=des_right_count;}
     if(l>r)
     {
      dwi=0.001 * (l-r);
      integrate=1;
     }
     else if(r>l)
     {
      dwi=0.001 *(r-l);
      integrate=2;
     }
     else if(r==l){dwi=0;integrate=0;}
     if((dwi<20) && (dwi>0))
      {
       dwi=2*dwi;
      }
     else if((dwi>100) || (dwi<0))
     { dwi=0;}
     if((integrate==1)||( integrate==0))
      {
       feed_count1=feed_count1-dwi;
       feed_count2=feed_count2+dwi;
      }
   else if(integrate==2)
     {
      feed_count1=feed_count1+dwi;
      feed_count2=feed_count2-dwi;
     }
    if(feed_count1<=feed_count2)
    {
     TURN=LEFT;
     COUNT=0;
     start_both_motors();
     outp(feed_count1,OCR2);
    }
   else if(feed_count2<feed_count1)
     {
      TURN=RIGHT;
      COUNT=0;
      start_both_motors();
      outp(feed_count2,OCR2);
     }
  }
else if(l+r>=des_distance)
  {
   stop_motors();
   update_odo();
   move_flag=0;
   move_clr=0;
   send_ack();
  }  
}
inline void reset() 
{
  compass_lock=0;
  compass_flag=0; 
  off_leds();
  init_pwm(); 
  init_opto();
  enable_compass();
  init_main();
  init_feed(); 
  stop_motors();
}

SIGNAL(SIG_OUTPUT_COMPARE1A)
{
msb1++;
outp(0x00,TCNT1H);
outp(0x00,TCNT1L);
}

SIGNAL(SIG_OVERFLOW0)
{
msb0++; 
}

SIGNAL(SIG_OUTPUT_COMPARE2)
{
 uint8_t tmp,tmp1;
  if(COUNT==0) 
  {
   if(TURN==RIGHT)
     {
      right_motor_stop();         
      tmp= feed_count1-feed_count2;
      if(tmp!=0)
       {
         TURN=LEFT;
	 COUNT++;
         tmp1=inp(TCNT2);  
	 tmp=tmp1+tmp;
	 outp(tmp,OCR2);
       }
       else if(tmp==0) 
        {
    	  left_motor_stop();
	  COUNT=0;
        }  	      
     }
  else if(TURN==LEFT)
    {
    left_motor_stop();     
    tmp= feed_count2-feed_count1;
     if(tmp!=0)
       {
        TURN=RIGHT;
        COUNT++;
        tmp1=inp(TCNT2);
	tmp=tmp1+tmp;
	outp(tmp,OCR2);
       }
     else if (tmp==0)
      {
       right_motor_stop();	
       COUNT=0;      
      } 
    }
  }	   
  else if(COUNT==1) 
  {
    if(TURN==RIGHT)
     {
      right_motor_stop();
     }
    else if(TURN==LEFT)
    {
     left_motor_stop();
    }
   COUNT=0;
  }
}
SIGNAL(SIG_OVERFLOW2) 
{ 
if(compass_lock==0)
  {
    charge_compass();
  }
if(move_flag==1)
 {
  pi_controller();
 }
communicate();
}

int main(void) 
{
static int i;
init_serial();
reset();
}
